#!/usr/bin/env python
#import matplotlib as mpl
#mpl.use("Agg")
import sys
import os
from pylab import *
from record_codec import *

results = []
time = []

def toPhysicalUnit(x, a, b):
        return (float(x) * ( float(1) / float(b) )) * 1000

def timeStepConverter(samples, samplesPerSecond):
    res = (1/float(samplesPerSecond))
    for i in range(samples):
        time.append(res*i)

def parsePG(pgrecord):
    raw = []

    f = open(pgrecord, "rb")
    sd = StreamDecoder(f)
    print "--- Header ---"
    print sd.header.unit_name                   
    print sd.header.samples_per_second          
    print sd.header.digital_channel_count       
    print sd.header.units_per_measuring_range    
    print sd.header.full_integer_range           
    print "--- --- --- ---"
    print sd.header.sample_count


    for i in range(0, sd.header.sample_count):
        value = toPhysicalUnit(sd.read(), sd.header.units_per_measuring_range, sd.header.full_integer_range)
        results.append(value)
    time = timeStepConverter(sd.header.sample_count, sd.header.samples_per_second)
    
def plotData():
    fig = figure(figsize=(9.5, 3.5))
    ax = fig.add_subplot(111)
    filtersize = 256

    ax.plot(time, results, alpha=0.125, color="r")
    conv_res = convolve(results, [1]*filtersize, "valid")/filtersize
    offset = (len(results) - len(conv_res))/2
    ax.plot(time[offset:-(offset+1)], conv_res, color="r")
    ax.grid(True)
    ax.set_xlabel("Time [s]")
    ax.set_ylabel("Current [mA]")
    locator_params(axis = 'y', nbins = 10)
    subplots_adjust(right=0.975, left=0.09, top=0.94, bottom=0.13) 
    show()
    #savefig("boot.png", dpi=300)

def main():
    parsePG("records/nexus_boot.pgrecord")
    print "mean {}".format(mean(results))
    print "median {}".format(median(results))
    print "min {}".format(min(results))
    print "max {}".format(max(results))   
    plotData()

if __name__ == '__main__':
    main()
